<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>LearnerSessionTracker.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.zookeeper.server.quorum</a> &gt; <span class="el_source">LearnerSessionTracker.java</span></div><h1>LearnerSessionTracker.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.zookeeper.server.quorum;

import java.io.PrintWriter;
import java.util.HashMap;
import java.util.concurrent.ConcurrentHashMap;

import org.apache.zookeeper.server.SessionTracker;
import org.apache.zookeeper.server.SessionTrackerImpl;
import org.apache.zookeeper.server.ZooKeeperServerListener;

/**
 * This is really just a shell of a SessionTracker that tracks session activity
 * to be forwarded to the Leader using a PING.
 */
public class LearnerSessionTracker implements SessionTracker {
    SessionExpirer expirer;

<span class="fc" id="L36">    HashMap&lt;Long, Integer&gt; touchTable = new HashMap&lt;Long, Integer&gt;();</span>
<span class="fc" id="L37">    long serverId = 1;</span>
<span class="fc" id="L38">    long nextSessionId=0;</span>
    
    private ConcurrentHashMap&lt;Long, Integer&gt; sessionsWithTimeouts;

    public LearnerSessionTracker(SessionExpirer expirer,
            ConcurrentHashMap&lt;Long, Integer&gt; sessionsWithTimeouts, long id,
<span class="fc" id="L44">            ZooKeeperServerListener listener) {</span>
<span class="fc" id="L45">        this.expirer = expirer;</span>
<span class="fc" id="L46">        this.sessionsWithTimeouts = sessionsWithTimeouts;</span>
<span class="fc" id="L47">        this.serverId = id;</span>
<span class="fc" id="L48">        nextSessionId = SessionTrackerImpl.initializeNextSession(this.serverId);</span>
        
<span class="fc" id="L50">    }</span>

    synchronized public void removeSession(long sessionId) {
<span class="fc" id="L53">        sessionsWithTimeouts.remove(sessionId);</span>
<span class="fc" id="L54">        touchTable.remove(sessionId);</span>
<span class="fc" id="L55">    }</span>

    public void shutdown() {
<span class="fc" id="L58">    }</span>

    synchronized public void addSession(long sessionId, int sessionTimeout) {
<span class="fc" id="L61">        sessionsWithTimeouts.put(sessionId, sessionTimeout);</span>
<span class="fc" id="L62">        touchTable.put(sessionId, sessionTimeout);</span>
<span class="fc" id="L63">    }</span>

    synchronized public boolean touchSession(long sessionId, int sessionTimeout) {
<span class="fc" id="L66">        touchTable.put(sessionId, sessionTimeout);</span>
<span class="fc" id="L67">        return true;</span>
    }

    synchronized HashMap&lt;Long, Integer&gt; snapshot() {
<span class="fc" id="L71">        HashMap&lt;Long, Integer&gt; oldTouchTable = touchTable;</span>
<span class="fc" id="L72">        touchTable = new HashMap&lt;Long, Integer&gt;();</span>
<span class="fc" id="L73">        return oldTouchTable;</span>
    }


    synchronized public long createSession(int sessionTimeout) {
<span class="fc" id="L78">        return (nextSessionId++);</span>
    }

    public void checkSession(long sessionId, Object owner)  {
        // Nothing to do here. Sessions are checked at the Leader
<span class="nc" id="L83">    }</span>
    
    public void setOwner(long sessionId, Object owner) {
        // Nothing to do here. Sessions are checked at the Leader
<span class="nc" id="L87">    }</span>

    public void dumpSessions(PrintWriter pwriter) {
    	// the original class didn't have tostring impl, so just
    	// dup what we had before
<span class="fc" id="L92">    	pwriter.println(toString());</span>
<span class="fc" id="L93">    }</span>

    public void setSessionClosing(long sessionId) {
        // Nothing to do here.
<span class="nc" id="L97">    }</span>
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>